program gen(input,output);
var n,i,j,k,p,q,hib,lgn : integer;
x : array[1..100] of integer;
s,t : string;

procedure nf(i,a:integer); {i is normal form wrt a}
var j : integer;
begin
for j := 1 to n do 
writeln('  (not (A ',a,' ',i,' ',j,'))');
end;

procedure subs(a,b:integer); {a is subset of b}
var i,j : integer;
begin
for i := 1 to n do
for j := 1 to n do 
writeln('  (implies (A ',a,' ',i,' ',j,') (A ',b,' ',i,' ',j,'))');
end;

procedure nsubs(a,b:integer); {a is not a subset of b}
var i,j : integer;
begin
writeln('  (not (and');
for i := 1 to n do
for j := 1 to n do 
writeln('  (implies (A ',a,' ',i,' ',j,') (A ',b,' ',i,' ',j,'))');
writeln('  ))');
end;

procedure irr(a:integer); {a is irreflexive}
var i : integer;
begin
for i := 1 to n do
writeln('  (not (A ',a,' ',i,' ',i,'))');
end;

procedure nirr(a:integer); {a is not irreflexive}
var i : integer;
begin
writeln('  (or');
for i := 1 to n do
writeln('  (A ',a,' ',i,' ',i,')');
writeln('  )');
end;

procedure trans(a:integer); {a is transitive}
var k,i,j : integer;
begin
for i := 1 to n do
for j := 1 to n do 
for k := 1 to n do
writeln('  (implies (and (A ',a,' ',i,' ',j,') (A ',a,' ',j,' ',k,')) (A ',a,' ',i,
' ',k,'))');
end;

procedure ntrans(a:integer); {a is not transitive}
var k,i,j : integer;
begin
writeln('  (not (and');
for i := 1 to n do
for j := 1 to n do 
for k := 1 to n do
writeln('  (implies (and (A ',a,' ',i,' ',j,') (A ',a,' ',j,' ',k,')) (A ',a,' ',i,
' ',k,'))');
writeln('  ))');
end;

procedure symm(a:integer); {a is symmetric}
var k,i,j : integer;
begin
for i := 1 to n do
for j := 1 to n do 
writeln('  (implies (A ',a,' ',i,' ',j,') (A ',a,' ',j,' ',i,'))');
end;

procedure sn(a:integer); {a is terminating}
var k,i,j : integer;
begin
hib := hib +1;
trans(hib);
{for i := 1 to n do
for j := 1 to n do 
for k := 1 to n do
writeln('  (implies (and (A ',a,' ',i,' ',j,') (A ',hib,' ',j,' ',k,')) (A ',hib,' ',i,
' ',k,'))');
for i := 1 to n do
for j := 1 to n do 
for k := 1 to n do
writeln('  (implies (and (A ',hib,' ',i,' ',j,') (A ',a,' ',j,' ',k,')) (A ',hib,' ',i,
' ',k,'))');
}
for i := 1 to n do
for j := 1 to n do 
writeln('  (implies (A ',a,' ',i,' ',j,') (A ',hib,' ',i,' ',j,'))');
for i := 1 to n do 
writeln('  (not (A ',hib,' ',i,' ',i,'))');
end;

{procedure nsn(a:integer); a is non-terminating, Thiemann
variant
var k,i,j : integer;
begin
hib := hib +1;
writeln('  (or');
for i := 1 to n do
writeln('  (A ',hib,' ',i,' ',i,')');
writeln('  )');
for i := 1 to n do
begin
writeln('  (or (not (A ',hib,' ',i,' ',i,'))'); 
for j := 1 to n do 
writeln('  (and (A ',a,' ',i,' ',j,') (A ',hib,' ',j,' ',j,'))'); 
writeln('  )');
end;
end;}

procedure compl(a:integer); {a is complete}
var k,i,j : integer;
begin
sn(a);
hib := hib +1;
for i := 1 to n do
  begin
  writeln('  (implies (and');
  nf(i,a);
  writeln('  ) (A ',hib,' ',i,' ',i,'))');
  end;
for i := 1 to n do
for j := 1 to n do 
writeln('  (implies (and (A ',hib-1,' ',i,' ',j,') (A ',hib,' ',j,' ',j,')) (A ',hib,' ',i,
' ',j,'))');
for k := 1 to n do
for i := 1 to n-1 do
for j := i+1 to n do 
writeln('  (not (and (A ',hib,' ',k,' ',i,') (A ',hib,' ',k,' ',j,')))');
end;

procedure kw(a,b:integer); {b := a^2}
var k,i,j : integer;
begin
for i := 1 to n do
for j := 1 to n do 
begin
writeln('  (iff (A ',b,' ',i,' ',j,') (or'); 
for k :=1 to n do
writeln('  (and (A ',a,' ',i,' ',k,') (A ',a,' ',k,' ',j,'))');
writeln('  ))'); 
end;
end;

procedure kwp(a,b:integer); {b := a cup a^2}
var k,i,j : integer;
begin
for i := 1 to n do
for j := 1 to n do 
begin
writeln('  (iff (A ',b,' ',i,' ',j,') (or'); 
writeln('  (A ',a,' ',i,' ',j,')'); 
for k :=1 to n do
writeln('  (and (A ',a,' ',i,' ',k,') (A ',a,' ',k,' ',j,'))');
writeln('  ))'); 
end;
end;

procedure kwrp(a,b:integer); {b := id cup a cup a^2}
var k,i,j : integer;
begin
for i := 1 to n do
for j := 1 to n do 
if i = j then
writeln('  (A ',b,' ',i,' ',j,')') else 
begin
writeln('  (iff (A ',b,' ',i,' ',j,') (or'); 
writeln('  (A ',a,' ',i,' ',j,')'); 
for k :=1 to n do
writeln('  (and (A ',a,' ',i,' ',k,') (A ',a,' ',k,' ',j,'))');
writeln('  ))'); 
end;
end;

function norm(a:integer):integer; {normal form}
var i,j : integer;
begin
hib := hib+1;
for i := 1 to n do
begin
writeln('  (iff (A ',hib,' ',i,' 1) (not (or');
for j := 1 to n do
writeln('  (A ',a,' ',i,' ',j,')');
writeln('  )))'); 
end;
norm := hib;
end;

function inv(a:integer):integer; {inverse}
var i,j : integer;
begin
hib := hib+1;
for i := 1 to n do
for j := 1 to n do 
writeln('  (iff (A ',hib,' ',i,' ',j,') (A ',a,' ',j,' ',i,'))'); 
inv := hib;
end;

function rc(a:integer):integer; {reflexive closure}
var i,j : integer;
begin
hib := hib+1;
for i := 1 to n do
for j := 1 to n do 
if i=j then 
writeln('  (A ',hib,' ',i,' ',j,')')  else
writeln('  (iff (A ',hib,' ',i,' ',j,') (A ',a,' ',i,' ',j,'))'); 
rc := hib;
end;

function trc(a:integer):integer; {transitive reflexive closure}
var i : integer;
begin
for i := 1 to lgn do
  begin
  hib := hib +1;
  if i = 1 then kwrp(a,hib) else kwp(hib-1,hib);
  end;
{trans(hib);}
trc := hib;
end;

function cmp(a,b:integer):integer; {composition}
var k,i,j : integer;
begin
hib := hib+1;
for i := 1 to n do
for j := 1 to n do 
begin
writeln('  (iff (A ',hib,' ',i,' ',j,') (or'); 
for k :=1 to n do
writeln('  (and (A ',a,' ',i,' ',k,') (A ',b,' ',k,' ',j,'))');
writeln('  ))'); 
end;
cmp := hib;
end;

function tc(a:integer):integer; {transitive closure}
var i : integer;
begin
for i := 1 to lgn do
  begin
  hib := hib +1;
  if i = 1 then kwp(a,hib) else kwp(hib-1,hib);
  end;
tc := hib;
end;

function peak(a,b:integer):integer; { <-a . ->b }
var k,i,j : integer;
begin
hib := hib+1;
for i := 1 to n do
for j := 1 to n do 
begin
writeln('  (iff (A ',hib,' ',i,' ',j,') (or'); 
for k :=1 to n do
writeln('  (and (A ',a,' ',k,' ',i,') (A ',b,' ',k,' ',j,'))');
writeln('  ))'); 
end;
peak := hib;
end;

function val(a,b:integer):integer; { ->a . <-b }
var k,i,j : integer;
begin
hib := hib+1;
for i := 1 to n do
for j := 1 to n do 
begin
writeln('  (iff (A ',hib,' ',i,' ',j,') (or'); 
for k :=1 to n do
writeln('  (and (A ',a,' ',i,' ',k,') (A ',b,' ',j,' ',k,'))');
writeln('  ))'); 
end;
val := hib;
end;

function union(a,b:integer):integer;
var k,i,j : integer;
begin
hib := hib+1;
for i := 1 to n do
for j := 1 to n do 
writeln('  (iff (A ',hib,' ',i,' ',j,') (or (A ',a,' ',i,' ',j,') (A ',b,' ',i,' ',j,')))');
union := hib;
end;

function inters(a,b:integer):integer;
var k,i,j : integer;
begin
hib := hib+1;
for i := 1 to n do
for j := 1 to n do 
writeln('  (iff (A ',hib,' ',i,' ',j,') (and (A ',a,' ',i,' ',j,') (A ',b,' ',i,' ',j,')))');
inters := hib;
end;

procedure disj(a,b:integer);
var i,j: integer;
begin
for i := 1 to n do 
for j := 1 to n do 
writeln('  (not (and (A ',a,' ',i,' ',j,') (A ',b,' ',i,' ',j,')))');
end;

procedure nsn(a:integer);
var b: integer;
begin
b := tc(a);
nirr(b);
end;

procedure un(a:integer);
var i,j,k,b,c: integer;
begin
b := trc(a);
c := norm(a);
for i := 1 to n do 
for j := 1 to n-1 do 
for k := j+1 to n do 
writeln('  (not (and (A ',b,' ',i,' ',j,') (A ',b,' ',i,' ',k,') (A
',c,' ',j,' 1) (A ',c,' ',k,' 1)))');
end;

procedure nun(a:integer);
var i,j,k,b,c: integer;
begin
b := trc(a);
c := norm(a);
writeln('  (not (and');
for i := 1 to n do 
for j := 1 to n-1 do 
for k := j+1 to n do 
writeln('  (not (and (A ',b,' ',i,' ',j,') (A ',b,' ',i,' ',k,') (A
',c,' ',j,' 1) (A ',c,' ',k,' 1)))');
writeln('  ))');
end;

procedure wn(a:integer);
var i,j,b,c: integer;
begin
b := trc(a);
c := norm(a);
for i := 1 to n do 
begin
writeln('  (or');
for j := 1 to n do 
writeln('  (and (A ',b,' ',i,' ',j,') (A ',c,' ',j,' 1))');
writeln('  )');
end;
end;

procedure nwn(a:integer);
var i,j,b,c: integer;
begin
b := trc(a);
c := norm(a);
writeln('  (not (and');
for i := 1 to n do 
begin
writeln('  (or');
for j := 1 to n do 
writeln('  (and (A ',b,' ',i,' ',j,') (A ',c,' ',j,' 1))');
writeln('  )');
end;
writeln('  ))');
end;

procedure wcr(a:integer);
var b,c,d: integer;
begin
c := peak(a,a);
b := trc(a);
d := val(b,b);
subs(c,d);
end;

procedure nwcr(a:integer);
var b,c,d: integer;
begin
c := peak(a,a);
b := trc(a);
d := val(b,b);
nsubs(c,d);
end;

procedure cr(a:integer);
var b,c,d: integer;
begin
b := trc(a);
c := peak(b,b);
d := val(b,b);
subs(c,d);
end;

procedure ncr(a:integer);
var b,c,d: integer;
begin
b := trc(a);
c := peak(b,b);
d := val(b,b);
nsubs(c,d);
end;

function arg: integer;
begin
if s[j] = 'x' then 
  begin
  j := j+3;
  {writeln('>>>x>>>>>', x[ord(s[j-2]) - ord('0')]);}
  arg := x[ord(s[j-2]) - ord('0')];
  end else
  begin
  j := j+2;
  {writeln('>>>>>>>>', ord(s[j-2]) - ord('0'));}
  arg := ord(s[j-2]) - ord('0');
  end;
end;

function argnr: integer;
var p,q : integer;
begin
j := j+2;
p := ord(s[j-2]) - ord('0');
q := ord(s[j-1]) - ord('0');
if q >= 0 then
if q <= 9 then p := 10*p+q;
argnr := p;
end;

procedure nriter(b:integer); {lgn := b}
begin lgn := b end;

procedure nrrules(a,b:integer); {a has at most b rules}
var i,j : integer;
begin
{writeln('; nrrules ',a,' ',b,', type = ',typ);}
writeln('  (>= ',b,' (+');
for i := 1 to n do
for j := 1 to n do
writeln('  (ite (A ',a,' ',i,' ',j,') 1 0)');
writeln('  ))');
end;

begin
readln(n);
{readln(lgn)};
lgn := 0;
k := 1;
while k<n do begin k:= 2*k; lgn := lgn+1; end;

readln(k);
writeln('(benchmark test.smt');
writeln('  :extrapreds ((A Int Int Int))');
writeln('  :formula');
writeln('  (and'); 
hib := k;
while not EOF do
  begin
  readln(s);
  if s <> '' then
  if s[1] <> ' ' then
  if s[1] = 'x' then
    begin
    i := ord(s[2]) - ord('0');
    j := 3;
    while s[j] in [' ','='] do j := j+1;
    t := s[j];
    while s[j+1] <> '(' do
      begin j := j+1; t := t+s[j]; end; 
    j := j+2;
    p := arg;
    if t = 'peak' then x[i] := peak(p,arg) else
    if t = 'trc' then x[i] := trc(p) else
    if t = 'tc' then x[i] := tc(p) else
    if t = 'inv' then x[i] := inv(p) else
    if t = 'rc' then x[i] := rc(p) else
    if t = 'val' then x[i] := val(p,arg) else
    if t = 'union' then x[i] := union(p,arg) else
    if t = 'inters' then x[i] := inters(p,arg) else
    if t = 'comp' then x[i] := cmp(p,arg) else
    writeln('syntax error');
    end
  else
    begin
    j := 1;
    t := s[j];
    while s[j+1] <> '(' do
      begin j := j+1; t := t+s[j]; end; 
    j := j+2;
    p := arg;
    if t = 'nriter' then nriter(p) else
    if t = 'nrrules' then nrrules(p,argnr) else
    if t = 'subs' then subs(p,arg) else
    if t = 'nsubs' then nsubs(p,arg) else
    if t = 'sn' then sn(p) else
    if t = 'nsn' then nsn(p) else
    if t = 'wcr' then wcr(p) else
    if t = 'cr' then cr(p) else
    if t = 'ncr' then ncr(p) else
    if t = 'nwcr' then nwcr(p) else
    if t = 'wn' then wn(p) else
    if t = 'nwn' then nwn(p) else
    if t = 'un' then un(p) else
    if t = 'nun' then nun(p) else
    if t = 'trans' then trans(p) else
    if t = 'ntrans' then ntrans(p) else
    if t = 'symm' then symm(p) else
    if t = 'irr' then irr(p) else
    if t = 'nirr' then nirr(p) else
    if t = 'compl' then compl(p) else
    if t = 'disj' then disj(p,arg) else
    if t = 'nf' then nf(p,arg) else
    if t = 'red' then 
      begin
      q := arg;
      writeln('  (A ',arg,' ',p,' ',q,')');
      end else
    writeln('syntax error');
    end;
  end;
writeln('  ))'); 
end.
